/**
 * @file actHeap_CheckAvail.c
 *
 * @brief IHEAP_CheackAvail Test
 */

#include "AEEHeap.h"

#include "act.h"
#include "ACTHeap.h"

static void setUp()
{
}


static void tearDown()
{
}


static void testHeap_CheckAvail1(ACTHeap* pMe)
{
    uint32 dwSize;
    boolean bVailable;

    // ACT_LOG("zero memory available");

    dwSize = 0; // in bytes
    bVailable = IHEAP_CheckAvail(pMe->pIHeap, dwSize);

    ACT_ASSERT(bVailable == TRUE);
}


static void testHeap_CheckAvail2(ACTHeap* pMe)
{
    uint32 dwSize;
    boolean bVailable;

    // ACT_LOG("memory available");

    dwSize = 1; // in bytes
    bVailable = IHEAP_CheckAvail(pMe->pIHeap, dwSize);

    ACT_ASSERT(bVailable == TRUE);
}


static void testHeap_CheckAvail3(ACTHeap* pMe)
{
    uint32 dwSize;
    boolean bVailable;

    // ACT_LOG("memory not available");

    dwSize = pMe->dwRAM; // in bytes
    bVailable = IHEAP_CheckAvail(pMe->pIHeap, dwSize+1);

    ACT_ASSERT(bVailable == FALSE);    
}


ITest* Heap_CheckAvailTests()
{
    ITestCaller* pCaller;

    ACT_TESTCALLER_NEW(pCaller, "Heap_CheckVailTests", setUp, tearDown);

    ACT_ADD_FIXTURE(pCaller, "testHeap_CheckAvail1", testHeap_CheckAvail1);
    ACT_ADD_FIXTURE(pCaller, "testHeap_CheckAvail2", testHeap_CheckAvail2);
    ACT_ADD_FIXTURE(pCaller, "testHeap_CheckAvail3", testHeap_CheckAvail3);
    
    return (ITest*) pCaller;
}
