/*
* Advanced CUnit Test - ACT version 0.5.55
* Copyright (C)  2004 Seo, Won Ho. All rights reserved.
*
* This file is a part of the Advanced CUnit Test.
* The use and distribution terms for this software are covered by the
* Common Public License 1.0 (http://opensource.org/licenses/cpl.php)
* which can be found in the file CPL.TXT at the root of this distribution.
* By using this software in any fashion, you are agreeing to be bound by
* the terms of this license. You must not remove this notice, or
* any other, from this software.
*/

/**
 * @file  exConSampleTest.c
 * @brief Console Sample Test
 */

#include "act.h"

extern ITest* PersonTest_tests(void);

extern ITest* CounterTest_tests(void);

int main (int argc, const char* argv[])
{
    ITestRunner* pTestRunner;

    act_createInstance(ACTCLSID_TESTRUNNER, (void**)&pTestRunner);
    
    ITestRunner_start(pTestRunner);

		ITestRunner_addTest(pTestRunner,PersonTest_tests());
		ITestRunner_addTest(pTestRunner,CounterTest_tests());

        ITestRunner_runTest(pTestRunner);

	ITestRunner_end(pTestRunner);
    
    ITestRunner_release(pTestRunner);
    return 0;
}

