/*
* Advanced CUnit Test - ACT version 0.5.55
* Copyright (C)  2004 Seo, Won Ho. All rights reserved.
*
* This file is a part of the Advanced CUnit Test.
* The use and distribution terms for this software are covered by the
* Common Public License 1.0 (http://opensource.org/licenses/cpl.php)
* which can be found in the file CPL.TXT at the root of this distribution.
* By using this software in any fashion, you are agreeing to be bound by
* the terms of this license. You must not remove this notice, or
* any other, from this software.
*/

#ifndef __SIMPLECALC_H__
#define __SIMPLECALC_H__

typedef struct __SimpleCalc SimpleCalc;
struct __SimpleCalc
{
    int m_nX;
    int m_nY;
};

SimpleCalc* SimpleCalc_Alloc(void);
void        SimpleCalc_Free(SimpleCalc* pMe);

SimpleCalc* SimpleCalc_Ctor(SimpleCalc* pMe);
SimpleCalc* SimpleCalc_CtorEx(SimpleCalc* pMe, int x, int y);

SimpleCalc* SimpleCalc_New(void);
SimpleCalc* SimpleCalc_NewEx(int x, int y);
void        SimpleCalc_Delete(SimpleCalc* pMe);

void        SimpleCalc_SetValue(SimpleCalc* pMe, int x, int y);
void        SimpleCalc_GetValue(SimpleCalc* pMe, int *x, int *y);
int         SimpleCalc_Sum(SimpleCalc* pMe);
int         SimpleCalc_Sub(SimpleCalc* pMe);

#endif // __SIMPLECALC_H__
