/*
* Advanced CUnit Test - ACT version 0.5.55
* Copyright (C)  2004 Seo, Won Ho. All rights reserved.
*
* This file is a part of the Advanced CUnit Test.
* The use and distribution terms for this software are covered by the
* Common Public License 1.0 (http://opensource.org/licenses/cpl.php)
* which can be found in the file CPL.TXT at the root of this distribution.
* By using this software in any fashion, you are agreeing to be bound by
* the terms of this license. You must not remove this notice, or
* any other, from this software.
*/

#ifndef __ACTSOURCELINE_H__
#define  __ACTSOURCELINE_H__

/*! \brief Constructs a SourceLine object initialized with the location where the macro is expanded.
 * \ingroup CreatingNewAssertions
 * \relates ISourceLine
 * Used to write your own assertion macros.
 * \see actasserter for example of usage.
 */
 #define ACT_SOURCELINE() act_createInstanceSourceLine( __FILE__ , __LINE__ )

typedef struct __ISourceLine ISourceLine;

typedef struct __ISourceLineVtbl ISourceLineVtbl;

struct __ISourceLineVtbl
{
	uint32 (*addRef)(ISourceLine* pobj);
};

ISourceLine* 
act_createInstanceSourceLine(char * filename, int linenumber);

#endif /*  __ACTSOURCELINE_H__ */

