/*
* Advanced CUnit Test - ACT version 0.5.55
* Copyright (C)  2004 Seo, Won Ho. All rights reserved.
*
* This file is a part of the Advanced CUnit Test.
* The use and distribution terms for this software are covered by the
* Common Public License 1.0 (http://opensource.org/licenses/cpl.php)
* which can be found in the file CPL.TXT at the root of this distribution.
* By using this software in any fashion, you are agreeing to be bound by
* the terms of this license. You must not remove this notice, or
* any other, from this software.
*/

#ifndef __ACTSTDLIB_H__
#define __ACTSTDLIB_H__

#ifdef	__cplusplus
extern "C" {
#endif

#ifndef NULL
#define	NULL	0
#endif

char*	act_strcpy(char *dst, const char *src);
char*	act_strncpy(char *dst, const char *src,unsigned int size);
char*	act_strcat(char *dst, const char *src);
char*	act_strncat(char *dst, const char *src,unsigned int count);
int		act_strlen(const char *str);
int		act_strcmp(const char *s1, const char *s2);
char*	act_itoa(int v,char *string,int r);
int		act_memcmp(const void *s1, const void *s2,unsigned int count);

#ifdef __WIN32


#endif

/*	#define NO_STDLIB*/
#ifdef	NO_STDLIB
	extern void act_print(const char *string);
#else
    #include<stdlib.h>
    #define act_free        free
    #define act_malloc  malloc
    #include <string.h>
    #define act_memset memset

#endif


#ifdef	__cplusplus
}
#endif

#endif /* __ACTSTDLIB_H__ */

