/*
* Advanced CUnit Test - ACT version 0.5.55
* Copyright (C)  2004 Seo, Won Ho. All rights reserved.
*
* This file is a part of the Advanced CUnit Test.
* The use and distribution terms for this software are covered by the
* Common Public License 1.0 (http://opensource.org/licenses/cpl.php)
* which can be found in the file CPL.TXT at the root of this distribution.
* By using this software in any fashion, you are agreeing to be bound by
* the terms of this license. You must not remove this notice, or
* any other, from this software.
*/

#ifndef __ACTTESTVECTOR_PRIVEATE_H__
#define __ACTTESTVECTOR_PRIVEATE_H__

#include "acttestvector_protected.h"

#ifdef __cplusplus
extern "C" {
#endif

       

static void        __ITestVec_push_back(ITestVec* pMe, ITest* pTest);
static void        __ITestVec_insert_before(ITestVec* pMe, int n, ITest* pTest);
static void        __ITestVec_erase(ITestVec* pMe, int n);
static int         __ITestVec_size(ITestVec* pMe);
static int         __ITestVec_capacity(ITestVec* pMe);
static ITest*      __ITestVec_get(ITestVec* pMe, int n);
static void        __ITestVec_clear(ITestVec* pMe);
static int         __ITestVec_find(ITestVec* pMe,ITest* pTest);



static void    __ITestVecIterator_First(ITestVecIterator* pme);
static void    __ITestVecIterator_Next(ITestVecIterator* pme);
static boolean __ITestVecIterator_IsDone(ITestVecIterator* pme);
static ITest* __ITestVecIterator_CurrentItem(ITestVecIterator* pme);

#ifdef __cplusplus
}
#endif

#endif /* __ACTTESTVECTOR_PRIVEATE_H__ */
