/*
* Advanced CUnit Test - ACT version 0.5.55
* Copyright (C)  2004 Seo, Won Ho. All rights reserved.
*
* This file is a part of the Advanced CUnit Test.
* The use and distribution terms for this software are covered by the
* Common Public License 1.0 (http://opensource.org/licenses/cpl.php)
* which can be found in the file CPL.TXT at the root of this distribution.
* By using this software in any fashion, you are agreeing to be bound by
* the terms of this license. You must not remove this notice, or
* any other, from this software.
*/

#ifndef __ACTTESTLISTENERMFC_PROTECTED_H__
#define __ACTTESTLISTENERMFC_PROTECTED_H__

#include "acttestlistenermfc.h"


struct __ITestListenerMfc
{
    ITestListenerMfcVtbl *pvt;
    uint32 m_cRef;
    TestRunnerDlg *m_pDlg;
};

//ITestListenerMfc * ITestListenerMfc_New(TestRunnerDlg *pDlg);
//void ITestListenerMfc_delete(ITestListenerMfc *pme);

ACTRESULT _ITestListenerMfc_new(ITestListenerMfc** ppobj);

void 
_ITestListenerMfc_ctor(ITestListenerMfc* pme, ITestListenerMfcVtbl* pvt);


void 
_ITestListenerMfc_initVtbl(ITestListenerMfcVtbl* pvt);


ACTRESULT 
_ITestListenerMfc_init(ITestListenerMfc* pobj, TestRunnerDlg * pDlg);


uint32 
_ITestListenerMfc_addRef(ITestListenerMfc* pobj);


uint32 
_ITestListenerMfc_release(ITestListenerMfc* pobj);


void 
_ITestListenerMfc_xtor(ITestListenerMfc* pme);

ACTRESULT 
_ITestListenerMfc_queryInterface(ITestListenerMfc* pobj, ACTCLSID clsid, void ** ppNew);

void 
_ITestListenerMfc_startTest(ITestListenerMfc* pme,ITest* test);

void 
_ITestListenerMfc_endTest(ITestListenerMfc* pme,ITest* test);

void 
_ITestListenerMfc_addFailure(ITestListenerMfc* pme,ITest* test,char* msg,int line,char* file);

#endif /* __ACTTESTLISTENERMFC_PROTECTED_H__ */
