/*
* Advanced CUnit Test - ACT version 0.5.55
* Copyright (C)  2004 Seo, Won Ho. All rights reserved.
*
* This file is a part of the Advanced CUnit Test.
* The use and distribution terms for this software are covered by the
* Common Public License 1.0 (http://opensource.org/licenses/cpl.php)
* which can be found in the file CPL.TXT at the root of this distribution.
* By using this software in any fashion, you are agreeing to be bound by
* the terms of this license. You must not remove this notice, or
* any other, from this software.
*/

#ifndef __ACTTESTRUNNERMFC_PROTECTED_H__
#define __ACTTESTRUNNERMFC_PROTECTED_H__

#include "acttestrunnermfc.h"

struct __ITestRunnerMfc {
	ITestRunnerMfcVtbl *pvt;

// protected member data
    uint32 m_cRef;
    ITestSuite *m_suite_;
    ITestVec *m_tests;
};

/*
ACTRESULT 
_ITestRunnerMfc_new(ITestRunnerMfc** ppobj);
*/
void 
_ITestRunnerMfc_ctor(ITestRunnerMfc* pme, ITestRunnerMfcVtbl* pvt);


void 
_ITestRunnerMfc_initVtbl(ITestRunnerMfcVtbl* pvt);

ACTRESULT 
_ITestRunnerMfc_init(ITestRunnerMfc* pobj);

uint32 
_ITestRunnerMfc_addRef(ITestRunnerMfc* pobj);


uint32 
_ITestRunnerMfc_release(ITestRunnerMfc* pobj);


void 
_ITestRunnerMfc_xtor(ITestRunnerMfc* pme);


ACTRESULT 
_ITestRunnerMfc_queryInterface(ITestRunnerMfc* pobj, ACTCLSID clsid, void ** ppNew);

#endif /* __ACTTESTRUNNERMFC_PROTECTED_H__ */
