
#include "wasrun.h"


typedef struct _cxWasRun
{
   AEEVTBL(IWasRun)    *pvt;        // BTIL Xtns are IWasRun objects
   AEEVTBL(cxWasRun)     vt_storage; // Storage for vtable pointers
   IModule              *pMod;       // The module we're in
   IShell               *pShell;     // The shell that we were given
   uint32                dwRefs;     // Our reference count
} cxWasRun;

static uint32 cxWasRun_AddRef(IWasRun *po)                    // C
{
   // The following is standard extension AddRef code
   cxWasRun *pme = (cxWasRun*)po;
   return ++pme->dwRefs;
}

static uint32 cxWasRun_AddRef(IWasRun *po)                    // C
{
   // The following is standard extension AddRef code
   cxWasRun *pme = (cxWasRun*)po;
   return ++pme->dwRefs;
}

static uint32 cxWasRun_Release(IWasRun *po)                   // D
{
   // The following is standard extension Release code
   cxWasRun *pme = (cxWasRun*)po;
   if (pme->dwRefs > 1)
      return --pme->dwRefs;

   //CALLBACK_Cancel(&pme->cbReadable);
   //IBTILDISPATCH_Release(pme->pDispatch);                       // D.1
   ISHELL_Release(pme->pShell);
   IMODULE_Release(pme->pMod);
   FREE(pme);
   return 0;
}

static int cxWasRun_QueryInterface(IWasRun *po, AEECLSID cls, void **ppObj)
{                                                               // E
   switch (cls)
   {
      // Your extension *MUST* support QueryInterface for AEEIID_BTILXTN
      case AEECLSID_QUERYINTERFACE:
      case AEEIID_WASRUN:
      case AEECLSID_WASRUN:
         *ppObj = (void*)po;
         IQI_AddRef(*ppObj);
         return SUCCESS;
   }
   return EUNSUPPORTED;
}