#include "AEE.h"
#include "AEEStdLib.h"

#include "AEEForm.h"
#include "AEERootForm.h"
#include "AEEDialog.h"
#include "AppForm.h"

#include "testcxtest_res.h"
#include "ExitForm.h"

class AppForm
{
public:
	static void freeData(AppForm* pMe);
	static boolean HandleEvent(void *po, AEEEvent evt, uint16 wParam, uint32 dwParam);
	static int initData(AppForm* po, IForm** ppo, IShell *pIShell, IRootForm *pRootForm, IDisplay *pIDisplay);

    static boolean exitConfirmationDialog_HandleEvent(void *po, AEEEvent evt, uint16 wParam, uint32 dwParam);
protected:
private:
    boolean exitConfirmationDialog_onEvent(AEEEvent evt, uint16 wParam, uint32 dwParam);
	int CreateExitConfirmationDialog();
    void free();
	boolean onEvent(AEEEvent evt, uint16 wParam, uint32 dwParam);
	int init(IForm** ppo, IShell *pIShell, IRootForm *pRootForm, IDisplay *pIDisplay);
    IShell*         piShell;
    IDisplay*       piDisplay;
    IRootForm*      rootForm;
    
    IForm*          mainForm;
    HandlerDesc     mainFormHandler;
    
    IDialog*        exitConfirmationDialog;
    HandlerDesc     exitConfirmationHandler;
    

    ExitConfDialog* exitConfDialog;
    //IPopupMenu* optionsMenu;
    //HandlerDesc optionsMenuHandler;
    
    //IXYContainer* mainContainer;
    //IWidget* numberStatic;
    //IWidget* opStatic;
    
    //ModelListener pickVmListener;
    
    //uint32 nAccumulator;
    
    //AECHAR* operatorString;  //values to be populated in the pick widget array model
    

};

int AppForm_New(IForm** ppo, IShell *pIShell, IRootForm *pRootForm, IDisplay *pIDisplay) 
{
    int result=0;
    
    //allocate space for the form
    AppForm *pMe = MALLOCREC(AppForm);
    
    if(!pMe)
        return ENOMEMORY;

    result = AppForm::initData(pMe, ppo, pIShell, pRootForm, pIDisplay);
    if (result == 0)
    {
        //*ppo = (IForm*)pMe;    
    }

    return result;
    /*
    *ppo = pMe;
    pMe->piShell = piShell;
    pMe->rootForm = pRootForm;
    

    result = ISHELL_CreateInstance(pMe->piShell, AEECLSID_FORM, (void**) &pMe->mainForm);
    if(result==0) {
        *ppo = pMe->mainForm;
    }
    
    if(result==0) {
        
        result =  IFORM_SetSoftkeys(pMe->mainForm, CALCULATOR_RES_FILE, MAINFORMSOFTKEY1, MAINFORMSOFTKEY2);
        result += IFORM_SetResText(pMe->mainForm, FID_TITLE, CALCULATOR_RES_FILE, MAINFORMTITLE);
        
        HANDLERDESC_Init(&pMe->mainFormHandler, AppForm_HandleEvent, pMe, AppForm_Delete);
        IFORM_SetHandler(pMe->mainForm, &pMe->mainFormHandler);
    }
    
    if(result==0)
        result = AppForm_PopulateMainContainer(pMe);
    
    if(result==0)
        AppForm_UpdateValueModel(pMe);
    */
    return result;
}


int AppForm::initData(AppForm* po, IForm** ppo, IShell *pIShell, IRootForm *pRootForm, IDisplay *pIDisplay)
{
    return po->init(ppo, pIShell, pRootForm, pIDisplay);
}

int AppForm::init(IForm **ppo, IShell *pIShell, IRootForm *pRootForm, IDisplay *pIDisplay)
{
    int result;

    piShell     = pIShell;
    piDisplay   = pIDisplay;
    rootForm    = pRootForm;

    result = ISHELL_CreateInstance(piShell, AEECLSID_FORM, (void**) &mainForm);
    if(result==0) 
    {
        *ppo = mainForm;
    }
    
    if(result==0)
    {
        result =  IFORM_SetSoftkeys(mainForm, TESTCXTEST_RES_FILE, IDS_MAINFORM_SOFTKEY1, IDS_MAINFORM_SOFTKEY2);
        result += IFORM_SetResText(mainForm, FID_TITLE, TESTCXTEST_RES_FILE, IDS_MAINFORM_TITLE);
        
        HANDLERDESC_Init(&mainFormHandler, AppForm::HandleEvent, this, AppForm::freeData);
        IFORM_SetHandler(mainForm, &mainFormHandler);
    }
    
    //if(result==0)
    //    result = AppForm_PopulateMainContainer(pMe);
    
    //if(result==0)
    //    AppForm_UpdateValueModel(pMe);

    return result;
}

boolean AppForm::HandleEvent(void *po, AEEEvent evt, uint16 wParam, uint32 dwParam)
{
    return ((AppForm*)po)->onEvent(evt, wParam, dwParam);
}

void AppForm::freeData(AppForm *pMe)
{
    if(pMe)
    {
        pMe->free();
        FREE(pMe);
    }
    
}

void AppForm::free()
{
   if(mainForm)
      IFORM_Release(mainForm);

   if(exitConfirmationDialog)
      IDIALOG_Release(exitConfirmationDialog);
}

boolean AppForm::onEvent(AEEEvent evt, uint16 wParam, uint32 dwParam)
{
    if (evt == EVT_KEY)
    {
        switch(wParam) {
        case AVK_0:
        case AVK_1:  
        case AVK_2:  
        case AVK_3:
        case AVK_4:
        case AVK_5:
        case AVK_6:
        case AVK_7:
        case AVK_8:
        case AVK_9:
            // If a numeric key is pressed, set the number of pixels the pen should
            // move each time one of the direction keys is pressed.
            {
                return TRUE;
            }
            break;
            
        case AVK_CLR:
            {
                return TRUE;
            }
            break;
            
        case AVK_SOFT1:
            {
                return TRUE;
            }
            break;
            
        case AVK_SOFT2:
            {
                int result;
                result = ExitConfDialog_New(&exitConfDialog, piShell);
                if (result == 0)
                    IROOTFORM_PushForm(rootForm, (IForm*) ExitConfDialog::getIForm(exitConfDialog));
                //int result = CreateExitConfirmationDialog();

                //if(result == 0)
                //    IROOTFORM_PushForm(rootForm, (IForm*)exitConfirmationDialog);

                return TRUE;
            }
            break;
            
        default:
            break;
        }
    }

   //the  default form handler is swapped with the AppForm handler
   // calling this allows the default form handler to handle the event
   return HANDLERDESC_Call(&mainFormHandler, evt, wParam, dwParam);
}

static boolean exitConfirmationDialog_HandleEvent(void *po, AEEEvent evt, uint16 wParam, uint32 dwParam);

int AppForm::CreateExitConfirmationDialog()
{
    int result = 0;

    result = ISHELL_CreateInstance(piShell, AEECLSID_WARNDIALOG, (void**) &exitConfirmationDialog);

    if (result == SUCCESS)
    {
        IWidget* backdropWidget = NULL;
        IFORM_SetSoftkeys((IForm*)exitConfirmationDialog, TESTCXTEST_RES_FILE, IDS_EXITFORM_SOFTKEY1, IDS_EXITFORM_SOFTKEY2);
        IFORM_SetCancelKey((IForm*)exitConfirmationDialog, AVK_SOFT2);
        
        IFORM_SetResText((IForm*)exitConfirmationDialog, FID_TITLE, TESTCXTEST_RES_FILE, IDS_EXITFORM_TITLE);
        IFORM_SetResText((IForm*)exitConfirmationDialog, FID_TEXT, TESTCXTEST_RES_FILE, IDS_EXITFORM_TEXT);
        
        HANDLERDESC_Init(&exitConfirmationHandler, exitConfirmationDialog_HandleEvent, this, 0);
        IFORM_SetHandler((IForm*)exitConfirmationDialog, &exitConfirmationHandler);
        

    }
    return result;
}

boolean  AppForm::exitConfirmationDialog_HandleEvent(void *po, AEEEvent evt, uint16 wParam, uint32 dwParam)
{
    return ((AppForm*)po)->exitConfirmationDialog_onEvent(evt, wParam, dwParam);
}

// Warning dialog handler event
boolean  AppForm::exitConfirmationDialog_onEvent(AEEEvent evt, uint16 wParam, uint32 dwParam)
{
   if(evt == EVT_KEY) {

      switch(wParam) {
      case AVK_SOFT1:
         //okay: exit app
         int result;
         result = ISHELL_CloseApplet(piShell, FALSE);
         return TRUE;
      
      case AVK_SOFT2:
      case AVK_CLR:
         // release exit conf dialog
		  if(exitConfirmationDialog) {
            IDIALOG_Release(exitConfirmationDialog);
			exitConfirmationDialog = NULL;
		  }
      }
   }

   //the  default form handler is swapped with the exitConfirmationForm handler
   // calling this allows the default form handler to handle the event
   return HANDLERDESC_Call(&exitConfirmationHandler, evt, wParam, dwParam);
}


