#include "AEE.h"
#include "AEEForm.h"
#include "AEEDialog.h"

#include "ExitForm.h"
#include "testcxtest_res.h"

int ExitConfDialog_New(ExitConfDialog** ppObj, IShell* pIShell)
{
    int nErr = SUCCESS;

    ExitConfDialog* pMe = MALLOCREC(ExitConfDialog);

    if (pMe)
    {
        ExitConfDialog::Ctor(pMe,pIShell);
        *ppObj = pMe;
    }
    else 
    {
        nErr = ENOMEMORY;
    }

    return nErr;
}


void ExitConfDialog::Ctor(ExitConfDialog *po, IShell* pIShell)
{
    //HANDLERDESC_Init(&me->hd, me->pfnDefHandler, me, 0);
    po->setUp(pIShell);
}

void ExitConfDialog::Dtor(ExitConfDialog *po)
{
    if(po)
    {
        po->tearDown();
        FREE(po);
    }
    
}




boolean ExitConfDialog::HandleEvent(void *po, AEEEvent evt, uint16 wParam, uint32 dwParam)
{
    return ((ExitConfDialog*) po)->onEvent(evt, wParam, dwParam);
}

IForm* ExitConfDialog::getIForm(ExitConfDialog* po)
{
    return (IForm*)po->exitConfirmationDialog;
}
void ExitConfDialog::setUp(IShell* pIShell)
{
    int result = 0;

    piShell = pIShell;

    result = ISHELL_CreateInstance(piShell, AEECLSID_WARNDIALOG, (void**) &exitConfirmationDialog);

    if (result == SUCCESS)
    {
        IWidget* backdropWidget = NULL;
        IFORM_SetSoftkeys((IForm*)exitConfirmationDialog, TESTCXTEST_RES_FILE, IDS_EXITFORM_SOFTKEY1, IDS_EXITFORM_SOFTKEY2);
        IFORM_SetCancelKey((IForm*)exitConfirmationDialog, AVK_SOFT2);
        
        IFORM_SetResText((IForm*)exitConfirmationDialog, FID_TITLE, TESTCXTEST_RES_FILE, IDS_EXITFORM_TITLE);
        IFORM_SetResText((IForm*)exitConfirmationDialog, FID_TEXT, TESTCXTEST_RES_FILE, IDS_EXITFORM_TEXT);
        
        HANDLERDESC_Init(&exitConfirmationHandler, ExitConfDialog::HandleEvent, this, ExitConfDialog::Dtor);
        IFORM_SetHandler((IForm*)exitConfirmationDialog, &exitConfirmationHandler);
    }

}

void ExitConfDialog::tearDown()
{
    // release exit conf dialog
    if(exitConfirmationDialog) 
    {
        IDIALOG_Release(exitConfirmationDialog);
        exitConfirmationDialog = NULL;
    }    
}

boolean ExitConfDialog::onEvent(AEEEvent evt, uint16 wParam, uint32 dwParam)
{
   if(evt == EVT_KEY) {

      switch(wParam) {
      case AVK_SOFT1:
          {
             int result;
             //okay: exit app
             result = ISHELL_CloseApplet(piShell, FALSE);

             result = presenter->NotifyViewEvent(evt, wParam, dwParam);
             return TRUE;
          }
          break;
      
      case AVK_SOFT2:
      case AVK_CLR:
         // release exit confirm dialog
		  if(exitConfirmationDialog) {
            IDIALOG_Release(exitConfirmationDialog);
			exitConfirmationDialog = NULL;
		  }
      }
   }

   //the  default form handler is swapped with the exitConfirmationForm handler
   // calling this allows the default form handler to handle the event
   return HANDLERDESC_Call(&exitConfirmationHandler, evt, wParam, dwParam);
}

void ExitConfDialog::setPresenter(ExitConfPresenter *pPresenter)
{
    presenter = pPresenter;
}

void ExitConfModel::setPresenter(ExitConfPresenter *pPresenter)
{
    presenter = pPresenter;
}

boolean ExitConfModel::CanExit(int exitReason)
{
    return bCanExit;
}

void ExitConfModel::ExitApplet()
{
    ISHELL_CloseApplet(piShell,FALSE);
}

void ExitConfModel::Ctor(ExitConfModel *po, IShell *pIShell)
{
    po->piShell = pIShell;
    po->bCanExit = FALSE;
}

boolean ExitConfPresenter::NotifyViewEvent(AEEEvent evt, uint16 wParam, uint32 dwParam)
{
    boolean result = FALSE;
    if(evt == EVT_KEY && wParam == AVK_SOFT1)
    {
        result = exitConfModel->CanExit(0);
    }
    
    return result;
}
