/* $Id: qw_factory.h,v 1.1 2005/05/17 05:31:02 heavenzen Exp $
 *
 * factory.h
 * 
 * Copyright 2001-2003, Meiosys (www.meiosys.com). All rights reserved.
 * See the COPYING file for the terms of usage and distribution.
 */

#ifndef __sd_factory_h
#define __sd_factory_h

/**
 * @file factory.h
 */

#include <stdio.h>
#include "qw_types.h"

#include "begin_code.h"
/* Set up for C function definitions, even when using C++ */
#ifdef __cplusplus
extern "C" {
#endif

struct __sd_factory;
typedef struct __sd_factory sd_factory_t;

struct __sd_factory_ops
{
    void* (*fac_new)	(const char*);
    void  (*fac_delete)	(void*);
    void  (*fac_print)	(void*, FILE*);
};
typedef struct __sd_factory_ops sd_factory_ops_t;

extern sd_factory_t* sd_factory_new(const char* a_name, 
				    const sd_factory_ops_t* a_ops);
extern void	sd_factory_delete(sd_factory_t* a_this);
extern void*	sd_factory_get(sd_factory_t* a_this, const char* a_name);
extern void	sd_factory_destroy(sd_factory_t* a_this, void* a_pr);
extern void	sd_factory_print(const sd_factory_t* a_this, FILE* a_stream);

/* Ends C function definitions when using C++ */
#ifdef __cplusplus
}
#endif
#include "close_code.h"

#endif
