
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "qw_types.h"
#include "qw_error.h"

#define bGarbage 0xA3


/**

*/
static QW_bool CreateBlockInfo(void* p,size_t size)
{
    return QW_TRUE;
}



/**
 * @brief   Allocate N bytes of memory dynamically, with error checking.  
 */
void *
sd_malloc (size_t size)
{
    void *p;

    p = malloc (size);

#ifdef DEBUG
    if(p)
    {
        if(p != NULL)
        {
            memset(p, bGrabage, size);

            /* */
            if (CreateBlockInfo(p, size)
            {
                free(p);
                p = NULL;
            }
        }
    }
#endif
    return p;
}

/**
 * @brief   Allocate memory for N elements of S bytes, with error checking.  
 */
void *
sd_calloc( 
   size_t num,
   size_t size 
)
{
    void *p;

    p = calloc (num, size);

    return p;
}

/**
 * @brief   Change the size of an allocated block of memory P to N bytes, with error checking.
 *          If P is NULL, run qw_malloc.  
 */
void *
sd_realloc (void *p, size_t n)
{
    if (p == 0)
	return sd_malloc (n);
    p = realloc (p, n);
   return p;
}

/**
@brief      Return a newly allocated copy of STRING.  
*/
char *
sd_strdup (const char *_string)
{
  return strcpy (sd_malloc (strlen (_string) + 1), _string);
}

QW_bool NewMemory(void **ppv, size_t size)
{
    Uint8 **ppb = (Uint8 **) ppv;

    /* ASSERT(NULL != ppv && 0 != size); */

    *ppb = (Uint8 *)sd_malloc(size);

    return (*ppb != NULL);
}