/* $Id: layout_type_basic.h,v 1.1 2005/05/18 05:13:25 heavenzen Exp $
 *
 * layout_type_basic.h
 * 
 * Copyright 2001-2003, Meiosys (www.meiosys.com). All rights reserved.
 *
 * See the COPYING file for the terms of usage and distribution.
 */

#ifndef log4c_layout_type_basic_h
#define log4c_layout_type_basic_h

/**
 * @file layout_type_basic.h
 *
 * @brief Implement a basic layout.
 *
 * In @c log4j.PatternLayout conventions, the basic layout has the following
 * conversion pattern: @c "%P %c - %m\n".
 *
 * Where 
 * @li @c "%P" is the priority of the logging event
 * @li @c "%c" is the category of the logging event
 * @li @c "%m" is the application supplied message associated with the
 * logging event
 * 
 **/

#include "qw_types.h" //#include <log4c/defs.h>
#include <log4c/layout.h>

#include "begin_code.h"
/* Set up for C function definitions, even when using C++ */
#ifdef __cplusplus
extern "C" {
#endif//__LOG4C_BEGIN_DECLS

extern const log4c_layout_type_t log4c_layout_type_basic;

/* Ends C function definitions when using C++ */
#ifdef __cplusplus
}
#endif
#include "close_code.h"//__LOG4C_END_DECLS

#endif
