/* $Id: version.h,v 1.1 2005/05/18 05:13:25 heavenzen Exp $
 *
 * version.h
 * 
 * Copyright 2001-2003, Meiosys (www.meiosys.com). All rights reserved.
 *
 * See the COPYING file for the terms of usage and distribution.
 */

#ifndef log4c_version_h
#define log4c_version_h

/**
 * @file version.h
 *
 * @brief log4c version information
 **/

#include "qw_types.h" //#include <log4c/defs.h>

#include "begin_code.h"
/* Set up for C function definitions, even when using C++ */
#ifdef __cplusplus
extern "C" {
#endif//__LOG4C_BEGIN_DECLS

/**
 * constant macro holding the major version of log4c
 **/
#define LOG4C_MAJOR_VERSION 1
/**
 * constant macro holding the minor version of log4c
 **/
#define LOG4C_MINOR_VERSION 0
/**
 * constant macro holding the micro version of log4c
 **/
#define LOG4C_MICRO_VERSION 12

/**
 * constant variable holding the major version of log4c
 **/
extern const int log4c_major_version;
/**
 * constant variable holding the minor version of log4c
 **/
extern const int log4c_minor_version;
/**
 * constant variable holding the micro version of log4c
 **/
extern const int log4c_micro_version;

/**
 * @return a string containing the full log4c version
 **/
extern const char* log4c_version(void);

/* Ends C function definitions when using C++ */
#ifdef __cplusplus
}
#endif
#include "close_code.h"//__LOG4C_END_DECLS

#endif

