/* These are functions that need to be implemented by a port of QW */

#include "QW_thread_c.h"

/* This function creates a thread, passing args to QW_RunThread(),
   saves a system-dependent thread id in thread->id, and returns 0
   on success.
*/
extern int QW_SYS_CreateThread(QW_Thread *thread, void *args);

/* This function does any necessary setup in the child thread */
extern void QW_SYS_SetupThread(void);

/* This function waits for the thread to finish and frees any data
   allocated by QW_SYS_CreateThread()
 */
extern void QW_SYS_WaitThread(QW_Thread *thread);

/* This function kills the thread and returns */
extern void QW_SYS_KillThread(QW_Thread *thread);

